﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing.Text;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;

namespace HeuristicLab.Algorithms.IteratedSymbolicExpressionConstruction {
  public interface ISymbolicExpressionConstructionPolicy : IItem {
    void Initialize(SymbolicExpressionTreeProblem problem, IRandom random);
    ISymbolicExpressionTree Sample(out IEnumerable<Tuple<object, int>> stateActionSequence);
    void Update(IEnumerable<Tuple<object, int>> stateActionSequence, double quality);
  }
}
