﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HeuristicLab.Algorithms.IteratedSymbolicExpressionConstruction {
  // maps a state action pair to a quality
  // represents quality functions that use a table representation for states & actions and can therefore return the number of tries for each state/action pair
  public interface ITabularQualityFunction : IQualityFunction {
    double QVariance(object state, int action); // estimate for the variance of observed rewards
    int Tries(object state, int action);
  }
}
