﻿using System;
using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Algorithms.IteratedSymbolicExpressionConstruction {
  [StorableClass]
  [Item("TabularAvgQualityFunction", "")]
  internal class TabularAvgQualityFunction : TabularQualityFunctionBase {

    public TabularAvgQualityFunction()
      : base() {
    }

    #region item
    [StorableConstructor]
    protected TabularAvgQualityFunction(bool deserializing) : base(deserializing) { }
    protected TabularAvgQualityFunction(TabularAvgQualityFunction original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new TabularAvgQualityFunction(this, cloner);
    }
    #endregion

    protected override double CalculateNewQ(object state, int action, double observedQuality) {
      var delta = observedQuality - Q(state, action);
      return Q(state, action) + (1.0 / Tries(state, action)) * delta; // iterative calculation of mean
    }
  }
}
