﻿using System;
using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Algorithms.IteratedSymbolicExpressionConstruction {
  [StorableClass]
  [Item("TabularMaxQualityFunction", "")]
  internal class TabularMaxQualityFunction : TabularQualityFunctionBase {

    public TabularMaxQualityFunction()
      : base() {
    }

    #region item
    [StorableConstructor]
    protected TabularMaxQualityFunction(bool deserializing) : base(deserializing) { }
    protected TabularMaxQualityFunction(TabularMaxQualityFunction original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new TabularMaxQualityFunction(this, cloner);
    }
    #endregion

    protected override double CalculateNewQ(object state, int action, double observedQuality) {
      return Math.Max(Q(state, action), observedQuality);
    }
  }
}
